package com.knauf.ejb.kuchen;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * Title:
 * Description:  Dialog fr das Erstellen eines Kuchens.
 * Copyright:    Copyright (c) 2004
 * Company:
 * @author
 * @version 1.0
 */

public class DialogKuchen extends JDialog
{
  JPanel panel1 = new JPanel();
  JButton jButtonOK = new JButton();
  JButton jButtonCancel = new JButton();

  /**Wurde der Dialog mit einem Klick auf "OK" beendet ? */
  private boolean bolOKClicked = false;

  /**Der Kuchen-Name, wird beim Klick auf OK aus dem Textfeld geholt. */
  private String strName = "";
  JLabel jLabelName = new JLabel();
  JTextField jTextFieldName = new JTextField();
  GridBagLayout gridBagLayout1 = new GridBagLayout();

  /**Dialog erzeugen
   * @param frame Parent-Frame.
   */
  public DialogKuchen(Frame frame)
  {
	super(frame, "", true);
	try
	{
	  jbInit();
	  pack();
	}
	catch(Exception ex)
	{
	  ex.printStackTrace();
	}
  }

  /**Dialog ohne Parameter. Nur fr Design.
   *
   */
  public DialogKuchen()
  {
	this(null);
  }
  void jbInit() throws Exception
  {
	panel1.setLayout(gridBagLayout1);
	jButtonOK.setMaximumSize(new Dimension(95, 27));
	jButtonOK.setMinimumSize(new Dimension(95, 27));
	jButtonOK.setPreferredSize(new Dimension(95, 27));
	jButtonOK.setText("OK");
	jButtonOK.addActionListener(new java.awt.event.ActionListener()
	{
	  public void actionPerformed(ActionEvent e)
	  {
		jButtonOK_actionPerformed(e);
	  }
	});
	jButtonCancel.setMaximumSize(new Dimension(95, 27));
	jButtonCancel.setMinimumSize(new Dimension(95, 27));
	jButtonCancel.setPreferredSize(new Dimension(95, 27));
	jButtonCancel.setText("Abbrechen");
	jButtonCancel.addActionListener(new java.awt.event.ActionListener()
	{
	  public void actionPerformed(ActionEvent e)
	  {
		jButtonCancel_actionPerformed(e);
	  }
	});
	jLabelName.setText("Kuchen-Name:");
	jTextFieldName.setMinimumSize(new Dimension(100, 21));
	jTextFieldName.setPreferredSize(new Dimension(100, 21));
	jTextFieldName.setToolTipText("");
	this.setTitle("Kuchen bearbeiten");
	getContentPane().add(panel1);
	panel1.add(jButtonOK, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
			,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
	panel1.add(jButtonCancel, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
			,GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
	panel1.add(jLabelName, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
			,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
	panel1.add(jTextFieldName, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
			,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(10, 10, 10, 10), 0, 0));
  }

  /**Klick auf "OK".
   * @param e ActionEvent
   */
  void jButtonOK_actionPerformed(ActionEvent e)
  {
	//Speichern, ob auf OK geklickt wurde.
	this.bolOKClicked = true;

	//Den Kuchen-Namen speichern.
	this.strName = this.jTextFieldName.getText();

	this.dispose();
  }

  /**Klick auf Abbrechen: Dialog schlieen.
   * @param e ActionEvent.
   */
  void jButtonCancel_actionPerformed(ActionEvent e)
  {
	this.dispose();

  }

  /**Wurde der Dialog mit einem Klick auf OK beendet ?
   * @return TRUE, wenn OK geklickt wurde. FALSE bei Klick auf Abbrechen o..
   */
  public boolean isOKClicked()
  {
	return this.bolOKClicked;
  }

  /**Setzen des Namens.
   * Wird in Instanz-Variable + Textfeld geschrieben.
   * @param str_Name der Name.
   */
  public void setName(String str_Name)
  {
	this.strName = str_Name;
	this.jTextFieldName.setText(str_Name);
  }

  /**Abrufen des Namens. Wird beim OK-Klick in Instanzvariable geschrieben, diese wird
   * hier zurckgeliefert.
   * @return Der Name.
   */
  public String getName()
  {
	return this.strName;
  }
}