package com.knauf.ejb.kuchen;

import java.awt.*;
import java.awt.event.*;
import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;
import javax.ejb.FinderException;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.*;

public class KuchenFrame extends JFrame {
  JPanel contentPane;
  JLabel jLabelKuchen = new JLabel();
  JScrollPane jScrollPaneKuchen = new JScrollPane();
  JList jListKuchen = new JList();
  JButton jButtonNeu = new JButton();
  JButton jButtonBearbeiten = new JButton();
  JButton jButtonLoeschen = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();

  /**Kuchen-Home-Interface, wird im Konstruktor erzeugt. */
  private KuchenSingleHome kuchenHome = null;

  /**Vector mit den aktuell Primary keys der Kuchen in der Listbox */
  private Vector vectorPrimaryKey = null;

  /**Construct the frame*/
  public KuchenFrame()
  {
	enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	try
	{
	  jbInit();

	  //Alle Kuchen laden:

	  //Kuchen-Home-Interface holen:
	  InitialContext initialContext = new InitialContext();
	  Object homeref = initialContext.lookup ("java:comp/env/ejb/KuchenSingle");

	  this.kuchenHome = (KuchenSingleHome) PortableRemoteObject.narrow(homeref, KuchenSingleHome.class);

	  //Liste fllen
	  this.fillKuchen();
	}
	catch(Exception e)
	{
	  e.printStackTrace();
	}
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
	jLabelKuchen.setText("Vorhanden:");
	//setIconImage(Toolkit.getDefaultToolkit().createImage(KuchenFrame.class.getResource("[Your Icon]")));
	contentPane = (JPanel) this.getContentPane();
	contentPane.setLayout(gridBagLayout1);
	this.setSize(new Dimension(400, 300));
	this.setTitle("Kuchen + Co");
	jButtonNeu.setMaximumSize(new Dimension(95, 27));
	jButtonNeu.setMinimumSize(new Dimension(95, 27));
	jButtonNeu.setPreferredSize(new Dimension(95, 27));
	jButtonNeu.setToolTipText("");
	jButtonNeu.setText("Neu");
	jButtonNeu.addActionListener(new java.awt.event.ActionListener()
	{
	  public void actionPerformed(ActionEvent e)
	  {
		jButtonNeu_actionPerformed(e);
	  }
	});
	jButtonBearbeiten.setText("Bearbeiten");
	jButtonBearbeiten.addActionListener(new java.awt.event.ActionListener()
	{
	  public void actionPerformed(ActionEvent e)
	  {
		jButtonBearbeiten_actionPerformed(e);
	  }
	});
	jButtonLoeschen.setMaximumSize(new Dimension(95, 27));
	jButtonLoeschen.setMinimumSize(new Dimension(95, 27));
	jButtonLoeschen.setPreferredSize(new Dimension(95, 27));
	jButtonLoeschen.setText("Lschen");
	jButtonLoeschen.addActionListener(new java.awt.event.ActionListener()
	{
	  public void actionPerformed(ActionEvent e)
	  {
		jButtonLoeschen_actionPerformed(e);
	  }
	});
	contentPane.add(jLabelKuchen, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
			,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
	contentPane.add(jScrollPaneKuchen, new GridBagConstraints(0, 1, 1, 3, 1.0, 1.0
			,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(10, 10, 10, 10), 0, 0));
	contentPane.add(jButtonNeu, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
			,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
	contentPane.add(jButtonBearbeiten, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
			,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
	contentPane.add(jButtonLoeschen, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
			,GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
	jScrollPaneKuchen.getViewport().add(jListKuchen, null);
  }
  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
	super.processWindowEvent(e);
	if (e.getID() == WindowEvent.WINDOW_CLOSING) {
	  System.exit(0);
	}
  }

  /**Befllen der Kuchen-Liste.
   * @exception FinderException Fehler beim Suchen der listbox-Elemente
   * @exception RemoteException Fehler beim Suchen der listbox-Elemente
   */
  private void fillKuchen() throws FinderException, RemoteException
  {
	//Liste leeren:
	this.jListKuchen.removeAll();

	//Alle Kuchen holen:
	Collection collKuchen = kuchenHome.findAll();

	//Eine Liste der Namen erzeugen (toString eines Kuchen liefert den vom Container erzeugten Primary Key zurck !).
	Vector vectorNamen = new Vector();
	//Die Primary Keys ebenfalls in einer Instanzvariable speichern.
	this.vectorPrimaryKey = new Vector();
	Iterator iteratorKuchen = collKuchen.iterator();
	while (iteratorKuchen.hasNext() == true)
	{
	  KuchenSingle kuchenAktuell = (KuchenSingle) iteratorKuchen.next();
	  vectorNamen.add ( kuchenAktuell.getName() );
	  this.vectorPrimaryKey.add ( kuchenAktuell.getPrimaryKey() );
	}

	this.jListKuchen.setListData( vectorNamen.toArray() );

  }

  /**Klick auf "Neu": Anlegen eines neuen Kuchens.
   * @param e ActionEvent
   */
  void jButtonNeu_actionPerformed(ActionEvent e)
  {
	try
	{
	  //Dialog anzeigen:
	  DialogKuchen dialogKuchen = new DialogKuchen (this);

	  dialogKuchen.show();

	  //Wurde im Dialog auf OK geklickt ?
	  if (dialogKuchen.isOKClicked() == false)
		return;

	  //Neuen Kuchen erzeugen:
	  KuchenSingle kuchenNeu = this.kuchenHome.createByName(dialogKuchen.getName() );

	  //Liste neu fllen:
	  this.fillKuchen();
	}
	catch (Exception ex)
	{
	  ex.printStackTrace();
	}
  }

  /**Klick auf Bearbeiten: Den gewhlten Kuchen bearbeiten
   * @param e ActionEVent
   */
  void jButtonBearbeiten_actionPerformed(ActionEvent e)
  {
	try
	{
	  //Ist ein Kuchen gewhlt ?
	  if (this.jListKuchen.getSelectedIndex() == -1)
	  {
		JOptionPane.showMessageDialog (this, "Bitte whlen Sie einen Kuchen aus");
		return;
	  }

	  //Den primary Key zum gewhlten Objekt holen. Ist ein Integer (Key wird hier
	  //manuell erzeugt).
	  Integer intPrimaryKey = (Integer) this.vectorPrimaryKey.get ( this.jListKuchen.getSelectedIndex() );

	  //Den Kuchen dazu finden.
	  KuchenSingle kuchenEdit = this.kuchenHome.findByPrimaryKey(intPrimaryKey);

	  DialogKuchen dialogKuchen = new DialogKuchen (this);

	  //Den Namen in den Dialog setzen:
	  dialogKuchen.setName( kuchenEdit.getName() );

	  //Auf OK-Klick warten:
	  dialogKuchen.show();
	  if (dialogKuchen.isOKClicked() == false)
		return;

	  //Speichern:
	  kuchenEdit.setName( dialogKuchen.getName() );

	  //Fertig, Liste neu fllen.
	  this.fillKuchen();
	}
	catch (Exception ex)
	{
	  ex.printStackTrace();
	}
  }

  /**Klick auf "Lschen": Lschen des gewhlten Kuchens ohne weitere Kommentare.
   * @param e ActionEvent.
   */
  void jButtonLoeschen_actionPerformed(ActionEvent e)
  {
	try
	{
	  //Ist ein Kuchen gewhlt ?
	  if (this.jListKuchen.getSelectedIndex() == -1)
	  {
		JOptionPane.showMessageDialog (this, "Bitte whlen Sie einen Kuchen aus");
		return;
	  }

	  //Den primary Key zum gewhlten Objekt holen (ist hier Integer !)
	  Integer intPrimaryKey = (Integer) this.vectorPrimaryKey.get ( this.jListKuchen.getSelectedIndex() );

	  //Den Kuchen dazu finden.
	  KuchenSingle kuchenEdit = this.kuchenHome.findByPrimaryKey(intPrimaryKey);

	  //Lschen. (hier wre eine "Wollen Sie wirklich lschen"-Abfrage vorher ganz schn.
	  kuchenEdit.remove();

	  //Fertig, Liste neu fllen.
	  this.fillKuchen();
	}
	catch (Exception ex)
	{
	  ex.printStackTrace();
	}
  }
}