package com.knauf.ejb.kuchen;

import java.rmi.RemoteException;

/**
 * Bean implementation class for Enterprise Bean: KuchenSingle
 */
public abstract class KuchenSingleBean implements javax.ejb.EntityBean {
	private javax.ejb.EntityContext myEntityCtx;
	/**
	 * setEntityContext
	 */
	public void setEntityContext(javax.ejb.EntityContext ctx) {
		myEntityCtx = ctx;
	}
	/**
	 * getEntityContext
	 */
	public javax.ejb.EntityContext getEntityContext() {
		return myEntityCtx;
	}
	/**
	 * unsetEntityContext
	 */
	public void unsetEntityContext() {
		myEntityCtx = null;
	}
	/**
	 * ejbCreate
	 */
	public java.lang.Integer ejbCreate()
		throws javax.ejb.CreateException {
		//Die ID erzeugen wir hier manuell:
		setId(this.getNextId());
		return null;
	}
	
	/**Erzeugen eines Kuchen-Objekts, wobei der Name angegeben wird. Der Key automatisch
	 * erzeugt.
	 * @param str_Name Der Name des Kuchens.
	 * @return Immer NULL.
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public java.lang.Integer ejbCreateByName (String str_Name) throws javax.ejb.CreateException
	{
		this.setName(str_Name);
		//Die ID erzeugen wir hier manuell:
		setId(this.getNextId());

	  	return null;
	}


	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate()
		throws javax.ejb.CreateException {
	}
	
	/**Nach dem Erzeugen eines Kuchen-Objekts, wobei der Name angegeben wird: nichts besonderes zu tun.
	 * @param str_Name Der Name des Kuchens.
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public void ejbPostCreateByName (String str_Name) throws javax.ejb.CreateException
	{
	}
	
	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbLoad
	 */
	public void ejbLoad() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() throws javax.ejb.RemoveException {
	}
	/**
	 * ejbStore
	 */
	public void ejbStore() {
	}
	/**
	 * Get accessor for persistent attribute: id
	 */
	public abstract java.lang.Integer getId();
	/**
	 * Set accessor for persistent attribute: id
	 */
	public abstract void setId(java.lang.Integer newId);
	/**
	 * Get accessor for persistent attribute: name
	 */
	public abstract java.lang.String getName();
	/**
	 * Set accessor for persistent attribute: name
	 */
	public abstract void setName(java.lang.String newName);
	
	/**Von auen verwendbare Methode aus dem Home-Interface: Ermitteln der nchsten verfgbaren
	 * Kuchen-ID.
	 * @return Die neue Kuchen-ID, 1 grer als die maximal vorhandene ID. Wenn es keine gibt,
	 * wird "1" zurckgeliefert.
	 */
	public Integer getNextId()
	{
		Integer intMaxID = null;
		try
		{
			//Wir brauchen das Remote-Home-Interface, in dem die find-Methode definiert ist
			//wre bei einer ejbSelect-Methode nicht ntig gewesen !
			KuchenSingleHome kuchenHome = (KuchenSingleHome) this.getEntityContext().getEJBHome();
			KuchenSingle kuchenSingle = kuchenHome.findByMaxId();
			//Jetzt endlich die ID holen:
			intMaxID = kuchenSingle.getId();
		}
		catch (RemoteException rex)
		{
			throw new javax.ejb.EJBException ("Beim Ermitteln der MaxId fr Kuchen trat RemoteException auf", rex);
		}
		catch (javax.ejb.FinderException fex)
		{
			//Finder-Exception tritt beim allerersten Abrufen auf: in diesem Fall gibt es noch
			//keinen Kuchen.
			intMaxID = null;
		}
	
		if (intMaxID == null)
	 		intMaxID = new Integer (0);
		//Um 1 erhhen:
		return new Integer (intMaxID.intValue() + 1);
	}
}
